@REM This file switches the code from the first version of LoadTest
@REM to the second version of LoadTest, or back again, based on
@REM the existence of the "LoadTest1" or "LoadTest2" file in this
@REM directory.

@ECHO OFF
@REM Check if LoadTest1 file exists
IF EXIST "LoadTest1" GOTO :OneToTwo
goto :TwoToOne

:OneToTwo
del LoadTest1
@ECHO LoadTest2 is current >LoadTest2
@ECHO Switching to LoadTest (second version)
copy LoadTest2.class LoadTest.class
copy LoadTest2$1.class LoadTest$1.class
goto end

:TwoToOne
@del LoadTest2
@ECHO LoadTest1 is current >LoadTest1
@ECHO Switching to LoadTest (first version)
copy LoadTest1.class LoadTest.class
copy LoadTest1$1.class LoadTest$1.class
goto end


:end
