import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
 *
 */
public class EmpView
{
    IEmployeeModel model;

    /**
     *
     */
    public EmpView(IEmployeeModel m)
    {
        model = m;

        // Create split frame & subpanes
    }


    /**
     * Application entry point
     */
    public static void main (String args[])
    {
        EmpView view = new EmpView(getEmployeeModel(args));
    }
    

    /**
     *
     */
    private static IEmployeeModel getEmployeeModel(String[] args)
    {
        IEmployeeModel model = null;
        if (args != null)
        {
            for (int i=0; i<args.length; i++)
            {
                if (args[i].equals("-model:RDBMS"))
                {
                    // Set up JDBC Connection
                    java.sql.Connection conn = null;
                    try
                    {
                        // Load the JDBC driver into the JVM
                        Class.forName("jdbc.idbDriver");
                        java.util.Properties p = 
                            new java.util.Properties();
                        conn = 
                            java.sql.DriverManager.getConnection(
                                "jdbc:idb:employee.prp", p);
                    }
                    catch (Exception ex)
                    {
                        ex.printStackTrace();
                        return null;
                    }
                    model = new RDBMSModel(conn);
                }
                if (args[i].equals("-model:Hashtable"))
                {
                    model = new HashtableModel();

                    // Construct some default data for the model
                }
            }
        }
        
        return model;
    }
}
