package Employee;

import java.rmi.Remote;
import java.rmi.RemoteException;


/**
 *
 */
public interface IRMIModelRemoteInterface
    extends Remote
{
    public static final String RMI_BINDING_NAME =
        "Employee.RMIModel:1.0.0";


}


/**
 *
 */
interface IRemotePersonInterface extends Remote
{
    /**
     *
     */
    public String remoteGetFirstName()
        throws RemoteException;
    /**
     *
     */
    public void remoteSetFirstName(String fName)
        throws RemoteException;
    

    /**
     *
     */
    public String remoteGetMiddleName()
        throws RemoteException;
    /**
     *
     */
    public void remoteSetMiddleName(String mName)
        throws RemoteException;


    /**
     *
     */
    public String remoteGetLastName()
        throws RemoteException;
    /**
     *
     */
    public void remoteSetLastName(String lName)
        throws RemoteException;


    /**
     *
     */
    public String remoteGetSSN()
        throws RemoteException;
    /**
     *
     */
    public void remoteSetSSN(String ssn)
        throws RemoteException;

    
    /**
     *
     */
    public IContactInfo[] remoteGetContactInfo()
        throws RemoteException;
    /**
     *
     */
    public void remoteAddEMail(String desc, String email)
        throws RemoteException;
    /**
     *
     */
    public void remoteAddAddress(String desc, String street, String city, 
        String state, String zip, String country)
        throws RemoteException;
    /**
     *
     */
    public void remoteAddPhone(String desc, String prefix, 
        String number, String suffix)
        throws RemoteException;
    /**
     *
     */
    public void remoteRemoveContactInfo(IContactInfo contactInfo)
        throws RemoteException;
}
