package Employee;

import com.sun.media.jsdt.*;
import com.sun.media.jsdt.event.*;


class JSDTPerson
    implements IPerson, ByteArrayListener
{
    JSDTPerson()
    {
    }

    // IPerson methods
    /**
     *
     */
    public String getFirstName()
        throws BusinessLayerException
    {
        return null;
    }
    /**
     *
     */
    public void setFirstName(String fName)
        throws BusinessLayerException
    {
    }
    

    /**
     *
     */
    public String getMiddleName()
        throws BusinessLayerException
    {
        return null;
    }
    /**
     *
     */
    public void setMiddleName(String mName)
        throws BusinessLayerException
    {
    }


    /**
     *
     */
    public String getLastName()
        throws BusinessLayerException
    {
        return null;
    }
    /**
     *
     */
    public void setLastName(String lName)
        throws BusinessLayerException
    {
    }


    /**
     *
     */
    public String getSSN()
        throws BusinessLayerException
    {
        return null;
    }
    /**
     *
     */
    public void setSSN(String ssn)
        throws BusinessLayerException
    {
    }

    
    /**
     *
     */
    public IContactInfo[] getContactInfo()
        throws BusinessLayerException
    {
        return null;
    }
    /**
     *
     */
    public void addEMail(String desc, String email)
        throws BusinessLayerException
    {
    }
    /**
     *
     */
    public void addAddress(String desc, String street, String city, 
        String state, String zip, String country)
        throws BusinessLayerException
    {
    }
    /**
     *
     */
    public void addPhone(String desc, String prefix, 
        String number, String suffix)
        throws BusinessLayerException
    {
    }
    /**
     *
     */
    public void removeContactInfo(IContactInfo contactInfo)
        throws BusinessLayerException
    {
    }

    // ByteArrayListener methods
    public void byteArrayJoined(ByteArrayEvent evt) { }
    public void byteArrayLeft(ByteArrayEvent evt) { }
    public void byteArrayValueChanged(ByteArrayEvent evt) { }
    public void byteArrayInvited(ByteArrayEvent evt) { }
    public void byteArrayExpelled(ByteArrayEvent evt) { }
}


/**
 *
 */
public class JSDTModelServer
    implements Client, SessionManager, SessionListener
{
    // Internal data
    //
    private Session m_jsdtSession = null;


    /**
     *
     */
    public JSDTModelServer(IEmployeeModel model)
    {
        try
        {
            if (RegistryFactory.registryExists("socket") == false)
            {
                RegistryFactory.startRegistry("socket");
            }
    
            URLString url = URLString.createSessionURL("localhost",
                                4567, "socket", "JSDTModelSession");

            // Create and join the Session
            m_jsdtSession = SessionFactory.createSession(url, this);
            m_jsdtSession.join(this);

            // We need to be notified when a Client (other than
            // ourselves) creates a new ByteArray in the Session
            m_jsdtSession.addSessionListener(this);
        }
        catch (JSDTException jsdtEx)
        {
            jsdtEx.printStackTrace();
        }
    }


    //=====================================================
    // Client methods
    /**
     *
     */
    public Object authenticate(AuthenticationInfo info)
    {
        return null;
    }
    /**
     *
     */
    public String getName()
    {
        return "JSDTHost";
    }


    //=====================================================
    // SessionManager methods
    /**
     * Authenticate clients requesting access; do nothing, for now.
     */
    public boolean sessionRequest(Session session,
                                  AuthenticationInfo info,
                                  Client client)
    {
        String challenge = "<challenge>";
        String expectedResponse = "<response>";
        String reply = null;

        info.setChallenge(challenge);
        reply = (String)client.authenticate(info);
        return (reply == null);
            // For the moment, they *all* return null (no security)
    }


    //=====================================================
    // SessionListener methods
    /**
     *
     */
    public void byteArrayCreated(SessionEvent evt)
    {
        System.out.println("byteArrayCreated:");
        System.out.println("\tClient: " + evt.getClientName());
        //System.out.println("\tByteArray: " + (ByteArray)evt.getSource());
        System.out.println("\tResourceName: " + evt.getResourceName());
        System.out.println("\tSession: " + evt.getSession().toString());
        System.out.println("\ttoString: " + evt.toString());

        // Is this a new ByteArray?

        // Create a Token for this ByteArray object at the same time
        // for synchronization purposes

        // Add a ByteArrayListener to update the model on
        // modification from the various clients
    }
    /**
     *
     */
    public void byteArrayDestroyed(SessionEvent evt)
    {
        System.out.println("byteArrayDestroyed:");
        System.out.println("\tClient: " + evt.getClientName());
        //System.out.println("\tByteArray: " + (ByteArray)evt.getSource());
        System.out.println("\tResourceName: " + evt.getResourceName());
        System.out.println("\tSession: " + evt.getSession().toString());
        System.out.println("\ttoString: " + evt.toString());

        // Destroy the corresponding Token (?)
    }
    public void channelCreated(SessionEvent evt) { }
    public void channelDestroyed(SessionEvent evt) { }
    public void sessionDestroyed(SessionEvent evt) { }
    public void sessionJoined(SessionEvent evt)
    {
        System.out.println("SessionJoined: " + evt.toString());
    }
    public void sessionLeft(SessionEvent evt) { }
    public void sessionInvited(SessionEvent evt) { }
    public void sessionExpelled(SessionEvent evt) { }
    /**
     *
     */
    public void tokenCreated(SessionEvent evt)
    {
        System.out.println("tokenCreated:");
        System.out.println("\tClient: " + evt.getClientName());
        System.out.println("\tResourceName: " + evt.getResourceName());
        System.out.println("\tSession: " + evt.getSession().toString());
    }
    /**
     *
     */
    public void tokenDestroyed(SessionEvent evt)
    {
        System.out.println("tokenDestroyed:");
        System.out.println("\tClient: " + evt.getClientName());
        System.out.println("\tResourceName: " + evt.getResourceName());
        System.out.println("\tSession: " + evt.getSession().toString());
    }


    /**
     *
     */
    public static void main (String args[])
    {
        JSDTModelServer server = new JSDTModelServer(null);
        System.err.println("Setup and bound JSDT server.");
    }
}
