package Employee;

import ch.softwired.ibus.*;
import java.util.Hashtable;
import java.util.Vector;


/**
 *
 */
public class iBusModel
    implements IEmployeeModel
{
    // Internal data
    //
    private String m_hostURL;


    /**
     *
     */
    public iBusModel(String url)
    {
        m_hostURL = url;
    }

    /**
     * Create IPerson object
     */
    public IPerson createPerson(
        String firstName, String middleName, String lastName,
        String ssn)
        throws BusinessLayerException, DuplicateObjectException
    {
        return null;
    }
    
    /**
     * Create IEmployee object
     */
    public IEmployee createEmployee(
        String firstName, String lastName, String middleName,
        String ssn, IPosition position, int salary)
        throws BusinessLayerException, DuplicateObjectException
    {
        return null;
    }
    
    /**
     * Create IEmployee from IPerson
     */
    public IEmployee createEmployee(IPerson person, 
        IPosition position, int salary)
        throws BusinessLayerException, DuplicateObjectException
    {
        return null;
    }
    
    /**
     * Create IManager object
     */
    public IManager createManager(
        String firstName, String lastName, String middleName,
        String ssn, IPosition position, int salary)
        throws BusinessLayerException, DuplicateObjectException
    {
        return null;
    }

    /**
     * Create IManager from IEmployee
     */
    public IManager createManager(IEmployee employee)
        throws BusinessLayerException, DuplicateObjectException
    {
        return null;
    }
    
    /**
     * Create IDepartment object
     */
    public IDepartment createDepartment(
        String name, IDepartment parent)
        throws BusinessLayerException, DuplicateObjectException
    {
        return null;
    }
    
    /**
     * Create IPosition object
     */
    public IPosition createPosition(
        String title, String desc, int minSalary, int maxSalary)
        throws BusinessLayerException, DuplicateObjectException
    {
        return null;
    }



    /**
     * Query for all Persons
     */
    public IPerson[] findAllPersons()
        throws BusinessLayerException
    {
        try
        {
            Requester r = 
                new Requester(new Channel(
                    new ChannelURL("ibus://" + m_hostURL + "/Person.find")));
            Vector replies = r.request("");
    
            if (!replies.isEmpty())
            {
                System.out.println("Got a response");
                Response res = (Response)replies.elementAt(0);
                Vector response = (Vector)res.getObject();
                
                IPerson[] retArray = new IPerson[response.size()];
                for (int i=0; i<retArray.length; i++)
                {
                    retArray[i] = (IPerson)response.elementAt(i);
                }
    
                return retArray;
            }
            else
            {
                throw new BusinessLayerException
                    ("No response; no Responder listening?");
            }
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
            throw new BusinessLayerException(ex);
        }
    }
    
    /**
     * Query for all Persons by last name
     */
    public IPerson[] findPersonsByLastName(String lastName)
        throws BusinessLayerException
    {
        return null;
    }
    
    /**
     * Query for all Persons by SSN
     */
    public IPerson[] findPersonsBySSN(String ssn)
        throws BusinessLayerException
    {
        return null;
    }

    /**
     * Query for all Employees
     */
    public IEmployee[] findAllEmployees()
        throws BusinessLayerException
    {
        return null;
    }
    
    /**
     * Query for all Managers
     */
    public IManager[] findAllManagers()
        throws BusinessLayerException
    {
        return null;
    }
    
    /**
     * Query for all Positions
     */
    public IPosition[] findAllPositions()
        throws BusinessLayerException
    {
        return null;
    }
    
    /**
     * Query for all Departments
     */
    public IDepartment[] findAllDepartments()
        throws BusinessLayerException
    {
        return null;
    }
    
    /**
     * Query for "root" Department
     */
    public IDepartment findRootDepartment()
        throws BusinessLayerException
    {
        return null;
    }
        
        
        
    /**
     * Remove a Person from the system
     */
    public void removePerson(IPerson person)
        throws BusinessLayerException, IntegrityConstraintException,
            UnknownObjectException
    {
    }

    /**
     * Remove an Employee from the system
     */
    public void removeEmployee(IEmployee employee)
        throws BusinessLayerException, IntegrityConstraintException,
            UnknownObjectException
    {
    }

    /**
     * Remove a Person from the system
     */
    public void removeManager(IManager manager)
        throws BusinessLayerException, IntegrityConstraintException,
            UnknownObjectException
    {
    }

    /**
     * Remove a Department from the system
     */
    public void removeDepartment(IDepartment dept)
        throws BusinessLayerException, IntegrityConstraintException,
            UnknownObjectException
    {
    }

    /**
     * Remove a Position from the system
     */
    public void removePosition(IPosition position)
        throws BusinessLayerException, IntegrityConstraintException,
            UnknownObjectException
    {
    }


    /**
     *
     */
    public static void main (String args[])
        throws Exception
    {
        iBusModel model = new iBusModel("");

        IPerson[] person = model.findAllPersons();
    }
}
