import java.io.*;
import java.util.*;
import java.util.jar.*;
import java.util.zip.*;

public class JarLister
{
    public static void main (String args[])
        throws Exception
    {
        JarInputStream fin = 
            new JarInputStream(new FileInputStream(args[0]));

        Manifest manifest = fin.getManifest();
        if (manifest != null)
        {
            Attributes attribs = manifest.getMainAttributes();
            
            Set set = attribs.keySet();
            for (Iterator i = set.iterator(); i.hasNext(); )
            {
                Attributes.Name key = (Attributes.Name)i.next();
                System.out.println(key + ": " + 
                                   attribs.getValue(key));
            }
        }
    }
}
