import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


public class PluginOne
    implements PluginApp.Plugin
{
    static
    {
        PluginApp.registerPlugin(new PluginOne());
    }

    public PluginOne()
    { }

    public void addToMenuBar(JMenuBar menuBar)
    {
        System.out.println("addToMenuBar called");
        final JMenuBar menu = menuBar;

        // Put us into the "File" menu
        for (int i=0; i<menu.getMenuCount(); i++)
        {
            JMenu m = menu.getMenu(i);

            System.out.println(m.getText());
            if ("File".equals(m.getText()))
            {
                System.out.println("Found File menu; adding self");
                JMenuItem mi = new JMenuItem("PluginOne");
                mi.addActionListener(new ActionListener()
                {
                    public void actionPerformed(ActionEvent e)
                    {
                        int result = JOptionPane.showConfirmDialog(
                            null,
                            "Do you like PluginOne?",
                            "information",
                            JOptionPane.YES_NO_CANCEL_OPTION, 
                            JOptionPane.INFORMATION_MESSAGE);
                        if (result == JOptionPane.YES_OPTION)
                        {
                            JOptionPane.showMessageDialog(
                                null, "I'm glad");
                        }
                        else if (result == JOptionPane.NO_OPTION)
                        {
                            JOptionPane.showMessageDialog(
                                null, "I'm sorry to hear that");
                        }
                        else if (result == JOptionPane.CANCEL_OPTION)
                        {
                            JOptionPane.showMessageDialog(
                                null, "Operation cancelled");
                        }
                        else
                        {
                            // How is this possible?!? Swing is broken!
                        }
                    }
                });
                m.add(mi);
            }

            break;
        }
    }
    public boolean canQuit()
    {
        System.out.println("PluginOne sez yes, you may quit");
        return true;
    }
}
