import java.rmi.*;

/**
 * NameServerImpl3; to see the reason to extend an abstract class,
 * uncomment the commented-out class declaration and comment out
 * the other one and compile, rmic, and try to run the client
 */
public class NameServerImpl3 extends java.rmi.server.UnicastRemoteObject
    implements INameServer
//public class NameServerImpl3 extends NameServer
{
    /**
     *
     */
    public String generateName()
        throws java.rmi.RemoteException
    {
        String returnName = "Wilma";

        try
        {
            Naming.rebind(INameServer.RMI_BINDING_NAME,
                          new NameServerImpl1());
            System.out.println("NameServerImpl1 rebound");
        }
        catch (Exception ex)
        {
            returnName = ex.toString();
        }
        
        return returnName;
    }


    /**
     *
     */
    public NameServerImpl3()
        throws java.rmi.RemoteException
    { }

    
    /**
     *
     */
    public static void main (String args[])
        throws Exception
    {
        // Create an instance of NameServerImpl3 and
        // export it
        //
        Naming.bind(INameServer.RMI_BINDING_NAME,
                    new NameServerImpl3());
        System.out.println("NameServerImpl3 bound as '" +
                           INameServer.RMI_BINDING_NAME + "'");
    }
}
