import com.javageeks.client.*;

public class HeartbeatTest
{
    public static void main (String args[])
        throws Exception
    {
        // Make sure HeartbeatServer is started before running
        // this code; you'll get a 'connection refused' error
        // if not.
        HeartbeatListenerClient hcl =
            new HeartbeatListenerClient("localhost", 8080);

        HeartbeatListener hl = null;

        // Add a LogListener
        hl = new LogListener("heartbeat.log", true);
        hcl.addListener(hl);

        // Add an OutputStreamListener to console
        //hl = new OutputStreamListener(System.out);
        //hl.setVerbose(true);
        //hl.addListener(hl);

        // Start listening
        hcl.startListening();

        // Run for 5 minutes
        int secondsCount = 0;
        while (secondsCount < 5 * 60)
        {
            Thread.sleep(1000);
        }

        // Stop listening, then quit
        hcl.stopListening();
    }
}
