import java.io.*;
import java.net.*;
import com.javageeks.gjas.connection.HttpConnection;

public class Standalone
{
    static final String EOL = new String(new byte[] { (byte)'\r', (byte)'\n' });
    public static void main(String[] args)
        throws Exception
    {
        com.javageeks.gjas.ServerManager.instance();

        // Set up a web listener on port 7010
        ServerSocket ss = new ServerSocket(7010);

        String response = 
            "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD W3 HTML//EN\"><HTML><BODY>" +
            "<FORM ACTION=\"temp.html\" METHOD=\"POST\">" +
            "<INPUT TYPE=\"TEXT\" NAME=\"UserId\">" +
            "<INPUT TYPE=\"TEXT\" NAME=\"Password\">" +
            "<INPUT TYPE=\"SUBMIT\">" +
            "</FORM></BODY></HTML>";
        
        Socket s;
        while ((s = ss.accept()) != null)
        {
            final DataInputStream in = new DataInputStream(s.getInputStream());
            new Thread(new Runnable()
            {
                public void run()
                {
                    try
                    {
                        String inputLine;
                        while ((inputLine = in.readLine()) != null)
                        {
                            System.out.println(inputLine);
                            //if (done)
                            //{
                            //    doExit();
                            //}
                        }
                        in.close();
                    }
                    catch (Exception ex)
                    {
                    }
                }
            }).start();

            PrintWriter pw = new PrintWriter(new OutputStreamWriter(s.getOutputStream()));
            pw.print("HTTP/1.0 200 OK" + EOL);
            pw.print("Content-type: text/html" + EOL);
            pw.print("Content-Length: " + response.length() + EOL);
            pw.print(EOL);
            pw.print(response);
            pw.flush();
            s.getOutputStream().close();
        }
    }
}    