import EDU.oswego.cs.dl.util.concurrent.*;

/**
 * This is a demonstration of Doug Lea's Concurrent library; see the book
 * "Concurrent Programming in Java" for details.
 */
public class LeaFuture
{
    public static void main(String[] args)
        throws Exception
    {
        FutureResult fr = new FutureResult();
        Runnable cmd = fr.setter(new Callable() 
        {
            public Object call()
            {
                try
                {
                    Thread.sleep(5000);
                    System.out.println("call complete!");
                }
                catch (Exception ex)
                {   }
                return null;
            }
        });
        new ThreadedExecutor().execute(cmd);
        System.out.println("End of main()");
    }
}