/*public class ThreadExit
{
    public static void main(String[] args)
        throws Exception
    {
        Thread t = new Thread()
        {
            private void exit()
            {
                System.out.println("Thread.exit()");
            }
        };
        t.start();
        
        t.join();
    }
}
*/

class ExitableThread
    extends Thread
{
    private void exit()
    {
        System.out.println("ExitableThread.exit()");
    }
}

public class ThreadExit
{
    public static void main (String args[]) 
        throws Exception
    {
        Thread t = new ExitableThread();
        t.start();
        t.join();
    }
}
