import java.net.URL;
import java.net.URLClassLoader;

import java.io.*;

public class FTPURLClient
{
    /**
     * Attempt to instantiate an instance of the class
     * com.javageeks.util.Hello, found only on the javageeks.com
     * FTP server in the "examples" directory.
     */
    public static void main(String[] args)
        throws Exception
    {
        URL[] urlArray =
        {
            new URL("ftp", "reader:password@www.javageeks.com", 
                    "/examples")
        };

        URLClassLoader ucl = new URLClassLoader(urlArray);
        Object obj = 
            ucl.loadClass("Hello").newInstance();
            
        // Hello should print "Hello from JavaGeeks.com!" to the
        // System.out stream

        // NOTE: Because of the FTP URL bug described in the text,
        // this may not actually work as expected; were the URL
        // to use anonymous FTP access, and the FTP site to allow
        // for anonymous access, then it would work. Change the
        // above URL to be "ftp", "www.javageeks.com", "/examples"
        // to see this in action. Hopefully Sun will have this
        // fixed in a later rev of the JDK.
    }
}
