package Employee;

/**
 *
 */
public class BusinessLayerException extends Exception
{
    /**
     *
     */
    public BusinessLayerException()
    {
        super();
    }
    
    /**
     *
     */
    public BusinessLayerException(String msg)
    {
        super(msg);
    }
    
    /**
     *
     */
    public BusinessLayerException(Exception nestedEx)
    {
        super();
        
        m_nested = nestedEx;
    }
    
    /**
     *
     */
    public BusinessLayerException(String msg, Exception nestedEx)
    {
        super(msg);
        
        m_nested = nestedEx;
    }
    
    
    /**
     *
     */
    public String toString()
    {
        return super.toString() + "\n" + 
            "Nested: " + 
                (m_nested != null ?
                    m_nested.toString() :
                    "(null)");
    }
    
    
    // Internal members
    private Exception m_nested = null;
}    