package Employee;

import java.rmi.*;
import java.rmi.server.*;

/**
 *
 */
public class RMIModelRemoteServer extends UnicastRemoteObject
    implements IRMIModelRemoteInterface
{
    // Internal data
    //
    IEmployeeModel m_core = null;


    /**
     * RMIModelRemoteServer wraps around another IEmployeeModel
     * object; it provides communication only, no behavior
     */
    RMIModelRemoteServer(IEmployeeModel core)
        throws java.rmi.RemoteException, 
            java.rmi.AlreadyBoundException, 
            java.net.MalformedURLException
    {
        // Store wrapped Model object
        m_core = core;
        
        // Bind and return
        Naming.bind(RMI_BINDING_NAME, this);
    }


    //==============
    // IRMIModelRemoteInterface methods
    //




    /**
     *
     */
    public static void main(String[] args)
    {

    }
}
    
