import java.io.*;

public class Signal
{
    public static void main(String[] args)
        throws Exception
    {
        Signal s = new Signal();
        
        System.out.println("Setup complete");
        
        while (true)
            Thread.yield();
    }
    
    
    public Signal()
    {
        setSignalHandler();
    }
    
    private static void signalSent()
    {
        System.out.println("Signal handler called");
    }
    
    private native void setSignalHandler();
    static
    {
        System.loadLibrary("signal");
    }
}    