import java.rmi.*;
import java.util.*;
import javax.naming.*;
import javax.rmi.PortableRemoteObject;

/**
 *
 */
public class IIOPNameClient
{
    /**
     *
     */
    public static void main (String args[])
        throws Exception
    {
        // Set InitialContext properties
        Hashtable env = new Hashtable();
        env.put("java.naming.factory.initial",
                "com.sun.jndi.cosnaming.CNCtxFactory");
        env.put("java.naming.provider.url",
                "iiop://localhost:900");

        // Obtain JNDI InitialContext
        Context ic = new InitialContext(env);

        INameServer nameSvr =
            (INameServer)PortableRemoteObject.narrow(
                ic.lookup(INameServer.RMI_BINDING_NAME),
                INameServer.class);

        // Make remote call
        //
        String name = nameSvr.generateName();
        System.out.println("Generated name: " + name);
    }
}
