import java.rmi.*;

/**
 *
 */
public class NameClient
{
    /**
     *
     */
    public static void main (String args[])
        throws Exception
    {
        System.setSecurityManager(new RMISecurityManager());
        
        // Lookup host
        //
        String lookupName = "rmi://" + args[0] + "/" +
                            INameServer.RMI_BINDING_NAME;
        INameServer nameSvr =
            (INameServer)Naming.lookup(lookupName);

        // Make remote call
        //
        String name = nameSvr.generateName();
        System.out.println("Generated name: " + name);
    }
}
