import java.io.*;

/* 
 * This is the original code; compile and run this, then comment it out
 * (remove the first slash in the line just above the class declaration),
 * uncomment the other Evolution class definition (below), and run that.
 */
//*
public class Evolution
    implements Serializable
{
    public static void main(String[] args)
        throws Exception
    {
        // Create an instance
        //
        Evolution e = new Evolution();
        e.printIt();
        
        // Serialize it out
        //
        FileOutputStream fo = new FileOutputStream("evolve.tmp");
        ObjectOutputStream so = new ObjectOutputStream(fo);
        so.writeObject(e);
        so.flush();
        fo.close();
        
        // Deserialize it back in, just to make sure
        //
        FileInputStream fi = new FileInputStream("evolve.tmp");
        ObjectInputStream si = new ObjectInputStream(fi);
        Evolution e2 = (Evolution)si.readObject();
        e2.printIt();
        fi.close();
    }
    
    
    public Evolution()
    {
        m_data = new String("This is a test");
    }
    
    public void printIt()
    {
        System.out.println("Data: " + m_data);
    }
    private String m_data = new String("Default value");
}    
// */

/**
 * This is the "evolved" class; only run this after running the "original"
 * code, above, or the deserialization attempt in main() will fail.
 */
/*
public class Evolution
    implements Serializable
{
    public static void main(String[] args)
        throws Exception
    {
        // Deserialize the old instance
        //
        FileInputStream fi = new FileInputStream("evolve.tmp");
        ObjectInputStream si = new ObjectInputStream(fi);
        Evolution e = (Evolution)si.readObject();
        e.printIt();
        fi.close();
        
        // Change the "new" data
        //
        e.changeData2();

        // Serialize it out to a new file
        //
        FileOutputStream fo = new FileOutputStream("evolve2.tmp");
        ObjectOutputStream so = new ObjectOutputStream(fo);
        so.writeObject(e);
        so.flush();
        fo.close();
        
        // Deserialize it back in, just to make sure
        //
        fi = new FileInputStream("evolve2.tmp");
        si = new ObjectInputStream(fi);
        Evolution e2 = (Evolution)si.readObject();
        e2.printIt();
        fi.close();
    }
    
    public Evolution()
    {
        m_data = new String("This is a test");
    }
    
    public void printIt()
    {
        System.out.println("Data: " + m_data);
        System.out.println("Data2: " + m_data2);
    }
    
    public void changeData2()
    {
        m_data2 = new String("This is different.");
    }
    private String m_data = new String("Default value");
    private String m_data2 = new String("Default data2 value");

    static final long serialVersionUID = -282360125859716471L;
}
*/