import java.io.*;
import java.sql.*;
import java.util.*;

public class LoadClass
{
    public static void main(String[] args)
        throws Exception
    {
        // Load the IDB driver
        Class.forName("jdbc.idbDriver").newInstance();
        
        //
        Properties p = new Properties();
        Connection c =
            DriverManager.getConnection("jdbc:idb:sample.prp", p);
        
        // Find the .class file
        File file = new File(args[0]);
        if (!file.exists())
            throw new Exception("Usage: java LoadClass <class file name>");
        
        // Strip ".class" from the arg
        String classname = args[0].substring(0, args[0].lastIndexOf("."));
        
        FileInputStream fin = new FileInputStream(file.getCanonicalPath());
        PreparedStatement ps =
            c.prepareStatement("INSERT INTO class_tbl VALUES(\"" + args[0] +"\", ?)");
        //ps.setBinaryStream(1, fin, (int)file.length());
        ps.setString(1, classname);
        ps.executeUpdate();
        ps.close();
        
        Statement s = c.createStatement();
        ResultSet rs = s.executeQuery("SELECT * FROM class_tbl");
        while (rs.next())
        {
            ///System.out.print(rs.getString(1));
            System.out.print("'");
            System.out.print(new String(rs.getString(2)));
            System.out.println("'");
        }
    }
}    