import java.io.*;
import java.net.Socket;

/**
 * Implementation of the Echo service (RFC ???) using the new SocketServer
 * class discussed in Chapter Six.
 */
public class Echo2Service 
    extends com.javageeks.gjas.services.SocketServer
{
    public Echo2Service()
    {
        super(7);
    }

    /**
     * Handle a connection
     */
    public void serve(Socket socket)
        throws Exception
    {
        Reader fromSocket =
            new InputStreamReader(socket.getInputStream());
        Writer toSocket =
            new OutputStreamWriter(socket.getOutputStream());
    
        char[] buffer = new char[1024];
        int c;
        while ((c = fromSocket.read(buffer)) != -1)
        {
            toSocket.write(buffer, 0, c);
            toSocket.flush();
        }
    }
}