import java.io.*;
import java.net.Socket;
import com.javageeks.gjas.ConfigProperties;
import com.javageeks.gjas.services.Connection;

/**
 * Example Connection class; this looks different from the version
 * in the book's text because this version is the
 * post-ConfigProperties discussion at the end of Chapter 6.
 */
public class EchoConnection
    implements Connection
{
    public void serve(Socket socket, ConfigProperties configInfo)
        throws Exception
    {
        Reader fromSocket =
            new InputStreamReader(socket.getInputStream());
        Writer toSocket =
            new OutputStreamWriter(socket.getOutputStream());
    
        char[] buffer = new char[1024];
        int c;
        while ((c = fromSocket.read(buffer)) != -1)
        {
            toSocket.write(buffer, 0, c);
            toSocket.flush();
        }
    }
}